<script setup lang="ts">
import { onMounted, ref } from 'vue'

import GitApiCall from '@/api/gitApi'

interface Group {
  id: string
  name: string
}

const groups = ref<Group[]>([])
const pipelines = ref<Pipeline[]>([])

const docsUri = ref<string>(window.USER_GUIDE_URI)

const gitApi = new GitApiCall()

const getSubGroup = async () => {
  try {
    const response = await gitApi.getSubGroup(gitApi.vendorId)

    groups.value = response.data
    console.log('getSubGroup groups:', groups.value)
  }
  catch (error) {
    console.error('error getSubGroup:', error)
  }
}

const getPipelines = async () => {
  try {
    const response = await gitApi.getPipelinesList(28)

    pipelines.value = response.data
    console.log('getPipelines pipelines:', pipelines.value)
  }
  catch (error) {
    console.error('error getPipelines:', error)
  }
}

onMounted(() => {
  getSubGroup()
  getPipelines()
  docsUri.value = window.USER_GUIDE_URI
})
</script>

<template>
  <div>
    <VContainer class="fill-height">
      <VRow align-stretch>
        <!-- 👉 The Card for Vendors -->
        <VCol
          cols="12"
          sm="6"
          md="4"
          class="d-flex"
        >
          <VCard>
            <div class="d-flex flex-column-reverse flex-md-row">
              <div>
                <VCardItem>
                  <VCardTitle>
                    <RouterLink
                      class="p-0"
                      variant="plain"
                      size="x-large"
                      :to="{ name: 'vendors' }"
                    >
                      <VIcon
                        icon="tabler-layout-grid"
                        class="align-top"
                        size="22"
                      />
                      <span class="ms-2">Vendors</span>
                    </RouterLink>
                  </VCardTitle>
                </VCardItem>

                <VCardText>
                  Vendors contains all productions pipelines to onboard and test CNF.
                  Those pipelines are ordered by the the CNF vendors.
                </VCardText>

                <VCardActions class="d-flex flex-wrap justify-space-around">
                  <VBtn
                    v-for="(group) in groups"
                    :key="group.id"
                    class="card-link"
                    :to="{ name: 'vendors', params: { id: group.id } }"
                  >
                    {{ group.name }}
                  </VBtn>
                </VCardActions>
              </div>
            </div>
          </VCard>
        </VCol>

        <!-- 👉 The Card for Search Pipeline -->
        <VCol
          cols="12"
          sm="6"
          md="4"
          class="d-flex"
        >
          <VCard>
            <div class="d-flex flex-column-reverse flex-md-row">
              <div>
                <VCardItem>
                  <VCardTitle>
                    <RouterLink
                      class="p-0"
                      variant="plain"
                      size="x-large"
                      :to="{ name: 'search-pipeline' }"
                    >
                      <VIcon
                        icon="tabler-search"
                        class="align-top"
                        size="18"
                      />
                      <span class="ms-2">Search Pipeline</span>
                    </RouterLink>
                  </VCardTitle>
                </VCardItem>

                <VCardText>
                  You can search here for each pipeline that has been launched in the system and a quick view of their
                  status.
                </VCardText>

                <VCardActions class="d-flex flex-wrap justify-space-around">
                  <VBtn
                    v-for="(pipeline) in pipelines"
                    :key="pipeline.id"
                    class="card-link"
                    :href="pipeline.web_url"
                  >
                    {{ pipeline.id }}
                  </VBtn>
                </VCardActions>
              </div>
            </div>
          </VCard>
        </VCol>
        <!-- 👉 The Card for Dashboards -->

        <VCol
          cols="12"
          sm="6"
          md="4"
          class="d-flex"
        >
          <VCard>
            <div class="d-flex flex-column-reverse flex-md-row">
              <div>
                <VCardItem>
                  <VCardTitle>
                    <RouterLink
                      class="p-0"
                      variant="plain"
                      size="x-large"
                      :to="{ name: 'dashboards' }"
                    >
                      <VIcon
                        icon="tabler-device-heart-monitor"
                        class="align-top"
                        size="22"
                      />
                      <span class="ms-2">Dashboards</span>
                    </RouterLink>
                  </VCardTitle>
                </VCardItem>

                <VCardText>
                  Links to external dashboards, Grafana and Kibana, where you can find detailed system statistics..
                </VCardText>
              </div>
            </div>
          </VCard>
        </VCol>
      </VRow>
    </VContainer>
  </div>
</template>

<style scoped>
.image-gray-trans {
  opacity: 0.2; /* Establece la transparencia */
  filter: grayscale(80%); /* Desatura los colores al 50% */
}

.d-flex .v-card {
  display: flex;
  flex-direction: column;
}
</style>
